/* UserBox.c generated by valac 0.38.10, the Vala compiler
 * generated from UserBox.vala, do not modify */

/*
 * Copyright (c) 2011-2017 elementary LLC. (http://launchpad.net/wingpanel)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <act/act.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <cairo.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define SESSION_WIDGETS_TYPE_USERBOX (session_widgets_userbox_get_type ())
#define SESSION_WIDGETS_USERBOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SESSION_WIDGETS_TYPE_USERBOX, SessionWidgetsUserbox))
#define SESSION_WIDGETS_USERBOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SESSION_WIDGETS_TYPE_USERBOX, SessionWidgetsUserboxClass))
#define SESSION_WIDGETS_IS_USERBOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SESSION_WIDGETS_TYPE_USERBOX))
#define SESSION_WIDGETS_IS_USERBOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SESSION_WIDGETS_TYPE_USERBOX))
#define SESSION_WIDGETS_USERBOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SESSION_WIDGETS_TYPE_USERBOX, SessionWidgetsUserboxClass))

typedef struct _SessionWidgetsUserbox SessionWidgetsUserbox;
typedef struct _SessionWidgetsUserboxClass SessionWidgetsUserboxClass;
typedef struct _SessionWidgetsUserboxPrivate SessionWidgetsUserboxPrivate;
enum  {
	SESSION_WIDGETS_USERBOX_0_PROPERTY,
	SESSION_WIDGETS_USERBOX_USER_PROPERTY,
	SESSION_WIDGETS_USERBOX_IS_GUEST_PROPERTY,
	SESSION_WIDGETS_USERBOX_FULLNAME_PROPERTY,
	SESSION_WIDGETS_USERBOX_NUM_PROPERTIES
};
static GParamSpec* session_widgets_userbox_properties[SESSION_WIDGETS_USERBOX_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_USER_STATE (user_state_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SessionWidgetsUserbox {
	GtkListBoxRow parent_instance;
	SessionWidgetsUserboxPrivate * priv;
};

struct _SessionWidgetsUserboxClass {
	GtkListBoxRowClass parent_class;
};

struct _SessionWidgetsUserboxPrivate {
	ActUser* _user;
	gboolean _is_guest;
	gchar* _fullname;
	GraniteWidgetsAvatar* avatar;
	GtkLabel* fullname_label;
	GtkLabel* status_label;
};

typedef enum  {
	USER_STATE_ACTIVE,
	USER_STATE_ONLINE,
	USER_STATE_OFFLINE
} UserState;


static gpointer session_widgets_userbox_parent_class = NULL;

GType session_widgets_userbox_get_type (void) G_GNUC_CONST;
#define SESSION_WIDGETS_USERBOX_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SESSION_WIDGETS_TYPE_USERBOX, SessionWidgetsUserboxPrivate))
#define SESSION_WIDGETS_USERBOX_LOGGED_IN _ ("Logged in")
#define SESSION_WIDGETS_USERBOX_LOGGED_OFF _ ("Logged out")
#define SESSION_WIDGETS_USERBOX_ICON_SIZE 48
SessionWidgetsUserbox* session_widgets_userbox_new (ActUser* user);
SessionWidgetsUserbox* session_widgets_userbox_construct (GType object_type, ActUser* user);
SessionWidgetsUserbox* session_widgets_userbox_new_from_data (const gchar* fullname, gboolean logged_in, gboolean is_guest);
SessionWidgetsUserbox* session_widgets_userbox_construct_from_data (GType object_type, const gchar* fullname, gboolean logged_in, gboolean is_guest);
GType user_state_get_type (void) G_GNUC_CONST;
UserState session_widgets_userbox_get_user_state (SessionWidgetsUserbox* self);
gboolean session_widgets_userbox_get_is_guest (SessionWidgetsUserbox* self);
ActUser* session_widgets_userbox_get_user (SessionWidgetsUserbox* self);
UserState session_services_user_manager_get_guest_state (void);
UserState session_services_user_manager_get_user_state (guint32 uuid);
gboolean session_widgets_userbox_is_logged_in (SessionWidgetsUserbox* self);
void session_widgets_userbox_set_can_activate (SessionWidgetsUserbox* self, gboolean can_activate);
static void session_widgets_userbox_update (SessionWidgetsUserbox* self);
void session_widgets_userbox_update_state (SessionWidgetsUserbox* self);
static gboolean session_widgets_userbox_real_draw (GtkWidget* base, cairo_t* ctx);
static void session_widgets_userbox_set_user (SessionWidgetsUserbox* self, ActUser* value);
static void session_widgets_userbox_set_is_guest (SessionWidgetsUserbox* self, gboolean value);
const gchar* session_widgets_userbox_get_fullname (SessionWidgetsUserbox* self);
void session_widgets_userbox_set_fullname (SessionWidgetsUserbox* self, const gchar* value);
static GObject * session_widgets_userbox_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _session_widgets_userbox____lambda4_ (SessionWidgetsUserbox* self);
static void __session_widgets_userbox____lambda4__act_user_changed (ActUser* _sender, gpointer self);
static void session_widgets_userbox_finalize (GObject * obj);
static void _vala_session_widgets_userbox_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_session_widgets_userbox_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


SessionWidgetsUserbox* session_widgets_userbox_construct (GType object_type, ActUser* user) {
	SessionWidgetsUserbox * self = NULL;
	ActUser* _tmp0_;
	g_return_val_if_fail (user != NULL, NULL);
	_tmp0_ = user;
	self = (SessionWidgetsUserbox*) g_object_new (object_type, "user", _tmp0_, NULL);
	return self;
}


SessionWidgetsUserbox* session_widgets_userbox_new (ActUser* user) {
	return session_widgets_userbox_construct (SESSION_WIDGETS_TYPE_USERBOX, user);
}


SessionWidgetsUserbox* session_widgets_userbox_construct_from_data (GType object_type, const gchar* fullname, gboolean logged_in, gboolean is_guest) {
	SessionWidgetsUserbox * self = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (fullname != NULL, NULL);
	_tmp0_ = fullname;
	_tmp1_ = is_guest;
	self = (SessionWidgetsUserbox*) g_object_new (object_type, "fullname", _tmp0_, "is-guest", _tmp1_, "user", NULL, NULL);
	return self;
}


SessionWidgetsUserbox* session_widgets_userbox_new_from_data (const gchar* fullname, gboolean logged_in, gboolean is_guest) {
	return session_widgets_userbox_construct_from_data (SESSION_WIDGETS_TYPE_USERBOX, fullname, logged_in, is_guest);
}


UserState session_widgets_userbox_get_user_state (SessionWidgetsUserbox* self) {
	UserState result = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp3_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp1_ = self->priv->_is_guest;
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		ActUser* _tmp2_;
		_tmp2_ = self->priv->_user;
		_tmp0_ = _tmp2_ != NULL;
	}
	_vala_assert (_tmp0_, "is_guest || user != null");
	_tmp3_ = self->priv->_is_guest;
	if (_tmp3_) {
		UserState _tmp4_;
		_tmp4_ = session_services_user_manager_get_guest_state ();
		result = _tmp4_;
		return result;
	} else {
		ActUser* _tmp5_;
		guint _tmp6_;
		UserState _tmp7_;
		_tmp5_ = self->priv->_user;
		_tmp6_ = act_user_get_uid (_tmp5_);
		_tmp7_ = session_services_user_manager_get_user_state ((guint32) _tmp6_);
		result = _tmp7_;
		return result;
	}
}


gboolean session_widgets_userbox_is_logged_in (SessionWidgetsUserbox* self) {
	gboolean result = FALSE;
	UserState state = 0;
	UserState _tmp0_;
	gboolean _tmp1_ = FALSE;
	UserState _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = session_widgets_userbox_get_user_state (self);
	state = _tmp0_;
	_tmp2_ = state;
	if (_tmp2_ == USER_STATE_ONLINE) {
		_tmp1_ = TRUE;
	} else {
		UserState _tmp3_;
		_tmp3_ = state;
		_tmp1_ = _tmp3_ == USER_STATE_ACTIVE;
	}
	result = _tmp1_;
	return result;
}


void session_widgets_userbox_set_can_activate (SessionWidgetsUserbox* self, gboolean can_activate) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = can_activate;
	gtk_list_box_row_set_selectable ((GtkListBoxRow*) self, _tmp0_);
	_tmp1_ = can_activate;
	gtk_list_box_row_set_activatable ((GtkListBoxRow*) self, _tmp1_);
}


static void session_widgets_userbox_update (SessionWidgetsUserbox* self) {
	gboolean _tmp0_;
	GtkLabel* _tmp1_;
	ActUser* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_is_guest;
	if (_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->fullname_label;
	_tmp2_ = self->priv->_user;
	_tmp3_ = act_user_get_real_name (_tmp2_);
	_tmp4_ = g_strdup_printf ("<b>%s</b>", _tmp3_);
	_tmp5_ = _tmp4_;
	gtk_label_set_label (_tmp1_, _tmp5_);
	_g_free0 (_tmp5_);
	{
		GdkPixbuf* pixbuf = NULL;
		ActUser* _tmp6_;
		const gchar* _tmp7_;
		GdkPixbuf* _tmp8_;
		gint size = 0;
		GtkStyleContext* _tmp9_;
		gint _tmp10_;
		GdkPixbuf* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		GdkPixbuf* _tmp14_;
		GraniteWidgetsAvatar* _tmp15_;
		GdkPixbuf* _tmp16_;
		_tmp6_ = self->priv->_user;
		_tmp7_ = act_user_get_icon_file (_tmp6_);
		_tmp8_ = gdk_pixbuf_new_from_file (_tmp7_, &_inner_error_);
		pixbuf = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch10_g_error;
		}
		_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) self);
		_tmp10_ = gtk_style_context_get_scale (_tmp9_);
		size = _tmp10_ * SESSION_WIDGETS_USERBOX_ICON_SIZE;
		_tmp11_ = pixbuf;
		_tmp12_ = size;
		_tmp13_ = size;
		_tmp14_ = gdk_pixbuf_scale_simple (_tmp11_, _tmp12_, _tmp13_, GDK_INTERP_BILINEAR);
		_g_object_unref0 (pixbuf);
		pixbuf = _tmp14_;
		_tmp15_ = self->priv->avatar;
		_tmp16_ = pixbuf;
		granite_widgets_avatar_set_pixbuf (_tmp15_, _tmp16_);
		_g_object_unref0 (pixbuf);
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		GraniteWidgetsAvatar* _tmp17_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp17_ = self->priv->avatar;
		granite_widgets_avatar_show_default (_tmp17_, SESSION_WIDGETS_USERBOX_ICON_SIZE);
		_g_error_free0 (e);
	}
	__finally10:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void session_widgets_userbox_update_state (SessionWidgetsUserbox* self) {
	UserState state = 0;
	UserState _tmp0_;
	UserState _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = session_widgets_userbox_get_user_state (self);
	state = _tmp0_;
	_tmp1_ = state;
	session_widgets_userbox_set_can_activate (self, _tmp1_ != USER_STATE_ACTIVE);
	_tmp2_ = session_widgets_userbox_is_logged_in (self);
	if (_tmp2_) {
		GtkLabel* _tmp3_;
		_tmp3_ = self->priv->status_label;
		gtk_label_set_label (_tmp3_, SESSION_WIDGETS_USERBOX_LOGGED_IN);
	} else {
		GtkLabel* _tmp4_;
		_tmp4_ = self->priv->status_label;
		gtk_label_set_label (_tmp4_, SESSION_WIDGETS_USERBOX_LOGGED_OFF);
	}
	gtk_list_box_row_changed ((GtkListBoxRow*) self);
	gtk_widget_show_all ((GtkWidget*) self);
}


static gboolean session_widgets_userbox_real_draw (GtkWidget* base, cairo_t* ctx) {
	SessionWidgetsUserbox * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	cairo_t* _tmp2_;
	gboolean _tmp3_;
	self = (SessionWidgetsUserbox*) base;
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp0_ = gtk_list_box_row_get_selectable ((GtkListBoxRow*) self);
	if (!_tmp0_) {
		GtkStyleContext* _tmp1_;
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
		gtk_style_context_set_state (_tmp1_, GTK_STATE_FLAG_NORMAL);
	}
	_tmp2_ = ctx;
	_tmp3_ = GTK_WIDGET_CLASS (session_widgets_userbox_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_list_box_row_get_type (), GtkListBoxRow), _tmp2_);
	result = _tmp3_;
	return result;
}


ActUser* session_widgets_userbox_get_user (SessionWidgetsUserbox* self) {
	ActUser* result;
	ActUser* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_user;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void session_widgets_userbox_set_user (SessionWidgetsUserbox* self, ActUser* value) {
	g_return_if_fail (self != NULL);
	if (session_widgets_userbox_get_user (self) != value) {
		ActUser* _tmp0_;
		ActUser* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_user);
		self->priv->_user = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, session_widgets_userbox_properties[SESSION_WIDGETS_USERBOX_USER_PROPERTY]);
	}
}


gboolean session_widgets_userbox_get_is_guest (SessionWidgetsUserbox* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_guest;
	result = _tmp0_;
	return result;
}


static void session_widgets_userbox_set_is_guest (SessionWidgetsUserbox* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (session_widgets_userbox_get_is_guest (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_is_guest = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, session_widgets_userbox_properties[SESSION_WIDGETS_USERBOX_IS_GUEST_PROPERTY]);
	}
}


const gchar* session_widgets_userbox_get_fullname (SessionWidgetsUserbox* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_fullname;
	result = _tmp0_;
	return result;
}


void session_widgets_userbox_set_fullname (SessionWidgetsUserbox* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, session_widgets_userbox_get_fullname (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_fullname);
		self->priv->_fullname = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, session_widgets_userbox_properties[SESSION_WIDGETS_USERBOX_FULLNAME_PROPERTY]);
	}
}


static void _session_widgets_userbox____lambda4_ (SessionWidgetsUserbox* self) {
	session_widgets_userbox_update (self);
	session_widgets_userbox_update_state (self);
}


static void __session_widgets_userbox____lambda4__act_user_changed (ActUser* _sender, gpointer self) {
	_session_widgets_userbox____lambda4_ ((SessionWidgetsUserbox*) self);
}


static GObject * session_widgets_userbox_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SessionWidgetsUserbox * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	ActUser* _tmp10_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp18_;
	GtkGrid* _tmp19_;
	GraniteWidgetsAvatar* _tmp20_;
	GtkGrid* _tmp21_;
	GtkLabel* _tmp22_;
	GtkGrid* _tmp23_;
	GtkLabel* _tmp24_;
	GtkStyleContext* _tmp25_;
	GtkGrid* _tmp26_;
	parent_class = G_OBJECT_CLASS (session_widgets_userbox_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SESSION_WIDGETS_TYPE_USERBOX, SessionWidgetsUserbox);
	_tmp0_ = self->priv->_fullname;
	_tmp1_ = g_strdup_printf ("<b>%s</b>", _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->fullname_label);
	self->priv->fullname_label = _tmp3_;
	_g_free0 (_tmp2_);
	_tmp4_ = self->priv->fullname_label;
	gtk_label_set_use_markup (_tmp4_, TRUE);
	_tmp5_ = self->priv->fullname_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp5_, GTK_ALIGN_END);
	_tmp6_ = self->priv->fullname_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_START);
	_tmp7_ = (GtkLabel*) gtk_label_new (SESSION_WIDGETS_USERBOX_LOGGED_OFF);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->status_label);
	self->priv->status_label = _tmp7_;
	_tmp8_ = self->priv->status_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_START);
	_tmp9_ = self->priv->status_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp9_, GTK_ALIGN_START);
	_tmp10_ = self->priv->_user;
	if (_tmp10_ == NULL) {
		GraniteWidgetsAvatar* _tmp11_;
		_tmp11_ = granite_widgets_avatar_new_with_default_icon (SESSION_WIDGETS_USERBOX_ICON_SIZE);
		g_object_ref_sink (_tmp11_);
		_g_object_unref0 (self->priv->avatar);
		self->priv->avatar = _tmp11_;
	} else {
		ActUser* _tmp12_;
		const gchar* _tmp13_;
		GraniteWidgetsAvatar* _tmp14_;
		ActUser* _tmp15_;
		ActUser* _tmp16_;
		ActUser* _tmp17_;
		_tmp12_ = self->priv->_user;
		_tmp13_ = act_user_get_icon_file (_tmp12_);
		_tmp14_ = granite_widgets_avatar_new_from_file (_tmp13_, SESSION_WIDGETS_USERBOX_ICON_SIZE);
		g_object_ref_sink (_tmp14_);
		_g_object_unref0 (self->priv->avatar);
		self->priv->avatar = _tmp14_;
		_tmp15_ = self->priv->_user;
		g_signal_connect_object (_tmp15_, "changed", (GCallback) __session_widgets_userbox____lambda4__act_user_changed, self, 0);
		_tmp16_ = self->priv->_user;
		g_object_bind_property_with_closures ((GObject*) _tmp16_, "locked", (GObject*) self, "visible", G_BINDING_SYNC_CREATE | G_BINDING_INVERT_BOOLEAN, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
		_tmp17_ = self->priv->_user;
		g_object_bind_property_with_closures ((GObject*) _tmp17_, "locked", (GObject*) self, "no-show-all", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
		session_widgets_userbox_update (self);
	}
	_tmp18_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp18_);
	grid = _tmp18_;
	_tmp19_ = grid;
	_tmp20_ = self->priv->avatar;
	gtk_grid_attach (_tmp19_, (GtkWidget*) _tmp20_, 0, 0, 3, 3);
	_tmp21_ = grid;
	_tmp22_ = self->priv->fullname_label;
	gtk_grid_attach (_tmp21_, (GtkWidget*) _tmp22_, 3, 0, 2, 1);
	_tmp23_ = grid;
	_tmp24_ = self->priv->status_label;
	gtk_grid_attach (_tmp23_, (GtkWidget*) _tmp24_, 3, 1, 2, 1);
	_tmp25_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp25_, "menuitem");
	_tmp26_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp26_);
	session_widgets_userbox_update_state (self);
	_g_object_unref0 (grid);
	return obj;
}


static void session_widgets_userbox_class_init (SessionWidgetsUserboxClass * klass) {
	session_widgets_userbox_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SessionWidgetsUserboxPrivate));
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) session_widgets_userbox_real_draw;
	G_OBJECT_CLASS (klass)->get_property = _vala_session_widgets_userbox_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_session_widgets_userbox_set_property;
	G_OBJECT_CLASS (klass)->constructor = session_widgets_userbox_constructor;
	G_OBJECT_CLASS (klass)->finalize = session_widgets_userbox_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SESSION_WIDGETS_USERBOX_USER_PROPERTY, session_widgets_userbox_properties[SESSION_WIDGETS_USERBOX_USER_PROPERTY] = g_param_spec_object ("user", "user", "user", act_user_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SESSION_WIDGETS_USERBOX_IS_GUEST_PROPERTY, session_widgets_userbox_properties[SESSION_WIDGETS_USERBOX_IS_GUEST_PROPERTY] = g_param_spec_boolean ("is-guest", "is-guest", "is-guest", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SESSION_WIDGETS_USERBOX_FULLNAME_PROPERTY, session_widgets_userbox_properties[SESSION_WIDGETS_USERBOX_FULLNAME_PROPERTY] = g_param_spec_string ("fullname", "fullname", "fullname", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}


static void session_widgets_userbox_instance_init (SessionWidgetsUserbox * self) {
	self->priv = SESSION_WIDGETS_USERBOX_GET_PRIVATE (self);
	self->priv->_is_guest = FALSE;
}


static void session_widgets_userbox_finalize (GObject * obj) {
	SessionWidgetsUserbox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SESSION_WIDGETS_TYPE_USERBOX, SessionWidgetsUserbox);
	_g_object_unref0 (self->priv->_user);
	_g_free0 (self->priv->_fullname);
	_g_object_unref0 (self->priv->avatar);
	_g_object_unref0 (self->priv->fullname_label);
	_g_object_unref0 (self->priv->status_label);
	G_OBJECT_CLASS (session_widgets_userbox_parent_class)->finalize (obj);
}


GType session_widgets_userbox_get_type (void) {
	static volatile gsize session_widgets_userbox_type_id__volatile = 0;
	if (g_once_init_enter (&session_widgets_userbox_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SessionWidgetsUserboxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) session_widgets_userbox_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SessionWidgetsUserbox), 0, (GInstanceInitFunc) session_widgets_userbox_instance_init, NULL };
		GType session_widgets_userbox_type_id;
		session_widgets_userbox_type_id = g_type_register_static (gtk_list_box_row_get_type (), "SessionWidgetsUserbox", &g_define_type_info, 0);
		g_once_init_leave (&session_widgets_userbox_type_id__volatile, session_widgets_userbox_type_id);
	}
	return session_widgets_userbox_type_id__volatile;
}


static void _vala_session_widgets_userbox_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SessionWidgetsUserbox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SESSION_WIDGETS_TYPE_USERBOX, SessionWidgetsUserbox);
	switch (property_id) {
		case SESSION_WIDGETS_USERBOX_USER_PROPERTY:
		g_value_set_object (value, session_widgets_userbox_get_user (self));
		break;
		case SESSION_WIDGETS_USERBOX_IS_GUEST_PROPERTY:
		g_value_set_boolean (value, session_widgets_userbox_get_is_guest (self));
		break;
		case SESSION_WIDGETS_USERBOX_FULLNAME_PROPERTY:
		g_value_set_string (value, session_widgets_userbox_get_fullname (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_session_widgets_userbox_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SessionWidgetsUserbox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SESSION_WIDGETS_TYPE_USERBOX, SessionWidgetsUserbox);
	switch (property_id) {
		case SESSION_WIDGETS_USERBOX_USER_PROPERTY:
		session_widgets_userbox_set_user (self, g_value_get_object (value));
		break;
		case SESSION_WIDGETS_USERBOX_IS_GUEST_PROPERTY:
		session_widgets_userbox_set_is_guest (self, g_value_get_boolean (value));
		break;
		case SESSION_WIDGETS_USERBOX_FULLNAME_PROPERTY:
		session_widgets_userbox_set_fullname (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



